%let rep=%STR(C:\Users\FSEG\Desktop\panel_es);
libname rep "&rep";

data tab; set rep.panel_ech;
if profil=11111;/* cylindre, pour les exemples */
logY=log(Y);
logC=log(C);
logL=log(L);
lY=logY-logL;
LC=logC-logL;
run;

proc sort data=tab; by i;
/* within */
proc standard mean=0 data=tab out=within; by i;
var logY logC logL LY LC;
run;

symbol1 c=black v=plus i=RL;
proc gplot data=within;
plot LY*LC/href=0 vref=0;
run;
/* between */
proc means NOPRINT data=tab; by i;
var logY logC logL LY LC;
output out=between mean=;
run;
/* centrage global */
proc standard mean=0 data=between out=between; 
var logY logC logL LY LC;
run;
symbol1 c=black v=plus i=RL;
proc gplot data=between;
plot LY*LC/href=0 vref=0;
run;

proc means n uss data=within;
var logY logC logL LY LC;
output out=SW uss=logY logC logL LY LC;
run;

proc means n uss data=between; /* non dupliqu */
var logY logC logL LY LC;
output out=SB uss=logY logC logL LY LC;
run;

proc transpose data=SW out=SW(rename=(col1=SW)) ;
run;
proc transpose data=SB out=SB(rename=(col1=SB)) ;
run;

data S; merge SW SB;
STOT=SW+5*SB;
PARTW=SW/STOT;
proc print;
run;

/* within*/
proc reg data=within;
model LY=LC logL;
run;

proc reg data=within OUTEST=BW;
model LY=LC logL/noint;
run;
quit;
run;
proc iml;
use between; read all var {LY} into By;
             read all var {LC logL} into Bx;
use BW; read all var {LC logL} into bw;
alpha=By-Bx*t(bw);
create res from alpha[colname=("alpha")]; append from alpha;
quit;
run;
proc kde data=res; univar alpha/out=gr1;
symbol1 c=black i=join v=none;
proc gplot data=gr1;
plot density*value=var/href=0;
run;

data alpha; merge res between(keep=i);
run;

data tab3; merge tab alpha; by i;
run;

proc iml; 
use tab3; read all var {LY} into y;
          read all var {LC logL} into x;
		  read all var {alpha} into alpha;
use BW; read all var {LC logL} into bw; /*ligne*/
epsilon=y-x*t(bw)-alpha;
create res2 from epsilon[colname="Epsi"]; append from epsilon;
quit;
run;
proc univariate normal plot data=res2;
var epsi;
run;
proc standard mean=0 data=res2 out=res2; var epsi;
run;
proc kde data=res2; univar epsi/out=gr2;
symbol1 c=black i=join v=none;
proc gplot data=gr2;
plot density*value=var/href=0;
run;
data residus;
set gr1 gr2;
run;
symbol2 c=blue i=join v=none;
proc gplot data=residus;
plot density*value=var/href=0 haxis=-3 to 3;
run;
/* pt2 */
proc iml; 
use tab3; read all var {LY} into y;
          read all var {LC logL} into x;
		  read all var {alpha} into alpha;
use BW; read all var {LC logL} into bw; /*ligne*/
epsilon=y-x*t(bw)-alpha;
b0=sum(epsilon)/nrow(epsilon); /* constante */
epsilon=epsilon-b0;/* centr */
py=b0+x*t(bw)+alpha;
px=b0+x*t(bw);
res3=y||py||px||alpha||epsilon;
create res3 from res3[colname=("y"||"py"||"px"||"alpha"||"epsi")]; 
append from res3;
quit;
run;
symbol1 c=black v=plus i=RL;
proc gplot data=res3;
plot y*py;
run;
proc kde data=res3; univar y/out=gr1;
proc kde data=res3; univar py/out=gr2;
proc kde data=res3; univar px/out=gr3;
proc kde data=res3; univar alpha/out=gr4;
proc kde data=res3; univar epsi/out=gr5;
run;
/* srie, prvision et rsidu */
goptions reset=symbol colors=(black,purple,blue,green,orange,yellow,pink,red);
symbol1 v=none i=join;
data gr; set gr1 gr2 gr5;
symbol2 c=blue i=join v=none;
proc gplot data=gr;
plot density*value=var;
run;
/* prvision, variables et effet individuel */
data gr; set gr1 gr3 gr4;
symbol2 c=blue i=join v=none;
proc gplot data=gr;
plot density*value=var;
run;
/*tout */
data gr; set gr1 gr2 gr3 gr4 gr5;
symbol2 c=blue i=join v=none;
proc gplot data=gr;
plot density*value=var;
run;
